# PixelmonSpawnRestrictedArea

Have you ever built a big house, castle or stadium and have watched how Pokémon spawns randomly, feeling out of place? Are you the owner of a server and want some specific areas to be free of Pokémon?

I have a solution for you.

PixelmonSpawnRestrictedArea is a Datapack that modifies the [Pixelmon Mod](https://reforged.gg/) spawn behavour. The main purpose of this datapack is to disable the spawn in certain areas of your world using Pixelmon's Better Spawner Feature basic configuration.

## Installation

Place the zip file inside the `datapack` folder of your world (Singleplayer and Server).  
For Singleplayer, it is usally located in `%Appdata%\Roaming\.minecraft\saves\[WORLDFOLDER]\datapacks`.

For further assistance visit [this guide](https://minecraft.fandom.com/wiki/Tutorials/Installing_a_data_pack).

## Usage and Instructions
### Structure  
Open the `betterspawnerconfig.json file inside \data\pixelmon\config` with a proper text editor.
```json
{
  "globalCompositeCondition": {
    "conditions": [],
    "anticonditions": [
      { 
        "minX": -100,
        "maxX": 50,
        "minZ": -100,
        "maxZ": 27,
        "dimensions": [
          "minecraft:overworld"
        ]
      },
      { 
        "minX": -500,
        "maxX": 50,
        "minZ": -100,
        "maxZ": 27,
        "dimensions": [
          "minecraft:overworld"
        ]
      }
    ]
  }
}
```

You will find one example inside the anticonditions paremeter.
* `minX` and `maxX` are the X coords limits.  
* `minY` and `maxY` are the X coords limits.  
>Make sure the desired area is correctly limited by this four coords. `min` parameters needs to be a lesser number than the `max` parameter of its axis.

>There is no need to be a square, so make sure your area fits in the polygon defined by these four points in the world.  

* `dimensions` parameter sets the desired dimension or dimensions this four points will take effect.

### How to add new restricted areas

Remove the example or change the coords and dimension according to your desired area. If you want to add more areas remember to add a `,` after the last area.

Unfortunately JSON files cannot add line comments and if you add a lot of areas you will lose track of which is which, so I've add a txt file in the root folder of the datapack called `listAreas.txt` for you to easily register all your areas and find them in the json file as soon as possible.

### Complex conditions

Pixelmon's Better Spawner Feature can go way further than what this datapack does. You can basically enable or disable certain Pokémon (Type, level...) to spawn in certain areas or biomes and under specific conditions like moon phases, weather, height, time, temperature, structures...

**I highly encourage you to customize this datapack according to your needs. You can check the official documentation:**  
[Better Spawner](https://pixelmonmod.com/wiki/Better_Spawner)  
[Better Spawner Config](https://pixelmonmod.com/wiki/Better_Spawner/Config)  
[Better Spawner Conditions](https://pixelmonmod.com/wiki/Better_Spawner/Spawn_Condition)  
[Better Spawner Template](https://www.planetminecraft.com/data-pack/betterspawnerconfig-template/)  

## Credits and License

[Pixelmon Mod](https://reforged.gg/)  
[MIT](https://choosealicense.com/licenses/mit/)  

Thanks to @sky_the_thunder for the help provided in the official Pixelmon Mod Discord.

-Kile (@Kile467) original author of the PixelmonSpawnRestrictedArea Datapack.